Subject: Re: Generic netlink interface help

From: Paul Moore <[email-masked]>
Date: Thu, 24 May 2007 09:21:37 -0400

On Thursday, May 24 2007 7:21:44 am Rodolfo Giometti wrote:
> On Thu, May 24, 2007 at 10:04:08AM -0000, Samuel Ortiz wrote:
> > Yes it's possible, even though it could be more tedious and painful.
>
> I know that. Have you some links to suggest to me in order to have
> some programming examples?

The libnl library itself is probably the best example that I have seen.  At 
it's core it is basically just regular Netlink with an extra layer of 
abstraction, i.e. a new header between the Netlink header and the payload.

Also, if you are still looking for in-kernel examples here are two _very_ 
simple ones which might help:

 * net/netlabel/netlabel_unlabeled.c:netlbl_unlabel_accept()
   This function reads a single attribute, NLBL_UNLABEL_A_ACPTFLG, sent
   from user space and acts on the value.

 * net/netlabel/netlabel_unlabeled.c:netlbl_unlabel_list()
   This function generates a reply message with a single attribute,
   NLBL_UNLABEL_A_ACPTFLG, in response to a request message.

-- 
paul moore
linux security @ hp